codeforces-500【B思维】【C贪心】

来源:互联网 发布:淘宝二手单反相机 编辑:程序博客网 时间:2024/05/29 11:35

题目链接:点击打开链接

A. New Year Transportation
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

New Year is coming in Line World! In this world, there are n cells numbered by integers from 1 to n, as a 1 × n board. People live in cells. However, it was hard to move between distinct cells, because of the difficulty of escaping the cell. People wanted to meet people who live in other cells.

So, user tncks0121 has made a transportation system to move between these cells, to celebrate the New Year. First, he thought of n - 1positive integers a1, a2, ..., an - 1. For every integer i where 1 ≤ i ≤ n - 1 the condition 1 ≤ ai ≤ n - i holds. Next, he made n - 1 portals, numbered by integers from 1 to n - 1. The i-th (1 ≤ i ≤ n - 1) portal connects cell i and cell (i + ai), and one can travel from cell i to cell (i + ai) using the i-th portal. Unfortunately, one cannot use the portal backwards, which means one cannot move from cell (i + ai) to cell iusing the i-th portal. It is easy to see that because of condition 1 ≤ ai ≤ n - i one can't leave the Line World using portals.

Currently, I am standing at cell 1, and I want to go to cell t. However, I don't know whether it is possible to go there. Please determine whether I can go to cell t by only using the construted transportation system.

Input

The first line contains two space-separated integers n (3 ≤ n ≤ 3 × 104) and t (2 ≤ t ≤ n) — the number of cells, and the index of the cell which I want to go to.

The second line contains n - 1 space-separated integers a1, a2, ..., an - 1 (1 ≤ ai ≤ n - i). It is guaranteed, that using the given transportation system, one cannot leave the Line World.

Output

If I can go to cell t using the transportation system, print "YES". Otherwise, print "NO".

Examples
input
8 41 2 1 2 1 2 1
output
YES
input
8 51 2 1 2 1 1 1
output
NO
Note

In the first sample, the visited cells are: 1, 2, 4; so we can successfully visit the cell 4.

In the second sample, the possible cells to visit are: 1, 2, 4, 6, 7, 8; so we can't visit the cell 5, which we want to visit.


/* 搜索 #include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int MAXN=3*1e4+10;int n,t;int a[MAXN];int mark[MAXN];bool flag;void find(int x){if(mark[x]==t||x==t){flag=1;return ;}else if(mark[x]==-1)return ;else find(mark[x]);}int main(){while(~scanf("%d %d",&n,&t)){memset(mark,-1,sizeof(mark));for(int i=1;i<n;i++){scanf("%d",&a[i]);mark[i]=i+a[i];}flag=0;if(mark[1]!=-1){find(mark[1]);}if(flag)puts("YES");elseputs("NO");}return 0;}*//* 标记:能到 i区域就能到 i + a[i] #include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int MAXN=3*1e4+10;int n,t;int a[MAXN];bool vis[MAXN];int main(){while(~scanf("%d %d",&n,&t)){memset(vis,0,sizeof(vis));vis[1]=1;for(int i=1;i<n;i++){scanf("%d",&a[i]);if(vis[i])vis[i+a[i]]=1;}if(vis[t])puts("YES");elseputs("NO");}return 0;}*/#include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int MAXN=3*1e4+10;int n,t;int a[MAXN];int main(){while(~scanf("%d %d",&n,&t)){for(int i=1;i<n;i++)scanf("%d",&a[i]);int cnt=1;while(cnt<t){cnt+=a[cnt];}if(cnt==t)puts("YES");elseputs("NO");}return 0;}

题目链接:点击打开链接

B. New Year Permutation
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

User ainta has a permutation p1, p2, ..., pn. As the New Year is coming, he wants to make his permutation as pretty as possible.

Permutation a1, a2, ..., an is prettier than permutation b1, b2, ..., bn, if and only if there exists an integer k (1 ≤ k ≤ n) where a1 = b1, a2 = b2, ..., ak - 1 = bk - 1 and ak < bk all holds.

As known, permutation p is so sensitive that it could be only modified by swapping two distinct elements. But swapping two elements is harder than you think. Given an n × n binary matrix A, user ainta can swap the values of pi and pj (1 ≤ i, j ≤ ni ≠ j) if and only if Ai, j = 1.

Given the permutation p and the matrix A, user ainta wants to know the prettiest permutation that he can obtain.

Input

The first line contains an integer n (1 ≤ n ≤ 300) — the size of the permutation p.

The second line contains n space-separated integers p1, p2, ..., pn — the permutation p that user ainta has. Each integer between 1and n occurs exactly once in the given permutation.

Next n lines describe the matrix A. The i-th line contains n characters '0' or '1' and describes the i-th row of A. The j-th character of thei-th line Ai, j is the element on the intersection of the i-th row and the j-th column of A. It is guaranteed that, for all integers i, j where 1 ≤ i < j ≤ nAi, j = Aj, i holds. Also, for all integers i where 1 ≤ i ≤ nAi, i = 0 holds.

Output

In the first and only line, print n space-separated integers, describing the prettiest permutation that can be obtained.

Examples
input
75 2 4 3 6 7 10001001000000000000101000001000000000100001001000
output
1 2 4 3 6 7 5
input
54 2 1 5 30010000011100100110101010
output
1 2 3 4 5
Note

In the first sample, the swap needed to obtain the prettiest permutation is: (p1, p7).

In the second sample, the swaps needed to obtain the prettiest permutation is (p1, p3), (p4, p5), (p3, p4).

permutation p is a sequence of integers p1, p2, ..., pn, consisting of n distinct positive integers, each of them doesn't exceed n. Thei-th element of the permutation p is denoted as pi. The size of the permutation p is denoted as n.

题意是根据矩阵判断两个元素之间能否进行直接交换,‘ 1 ’ 代表可以交换,‘ 0 ’ 代表不可以,要求输出经过几次交换后能得到的 “ 最完美的序列 ” ,‘‘ 最完美序列 ’’也就是尽量从小到大的排列的序列。

题解:值得注意的是这里的元素直接不止能进行直接交换,还能进行间接交换,所以先用 floyd 预处理找到所有能够交换(包括直接和间接)的元素,然后把能交换的元素进行冒泡就得到了“ 最完美序列 ”(因为其他的元素之间不能进行交换,只能按照原来的顺序)。

#include<cstdio>#include<algorithm>#include<cstring>#include<iostream>using namespace std;int n,a[310];char s[310][310];bool vis[310][310];int main(){while(~scanf("%d",&n)){for(int i=0;i<n;i++)scanf("%d",&a[i]);memset(vis,0,sizeof(vis));for(int i=0;i<n;i++){scanf("%s",s[i]);for(int j=0;j<n;j++){if(s[i][j]=='1')vis[i][j]=1;}}for(int k=0;k<n;k++){for(int i=0;i<n;i++){for(int j=0;j<n;j++){if(vis[i][k]&&vis[k][j])vis[i][j]=1;}}}for(int i=0;i<n;i++){for(int j=i+1;j<n;j++){if(vis[i][j]&&a[i]>a[j])swap(a[i],a[j]);}}for(int i=0;i<n;i++)printf(i==0?"%d":" %d",a[i]);puts("");}return 0;}

题目链接:点击打开链接

C. New Year Book Reading
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

New Year is coming, and Jaehyun decided to read many books during 2015, unlike this year. He has n books numbered by integers from 1 to n. The weight of the i-th (1 ≤ i ≤ n) book is wi.

As Jaehyun's house is not large enough to have a bookshelf, he keeps the n books by stacking them vertically. When he wants to read a certain book x, he follows the steps described below.

  1. He lifts all the books above book x.
  2. He pushes book x out of the stack.
  3. He puts down the lifted books without changing their order.
  4. After reading book x, he puts book x on the top of the stack.

He decided to read books for m days. In the j-th (1 ≤ j ≤ m) day, he will read the book that is numbered with integer bj (1 ≤ bj ≤ n). To read the book, he has to use the process described in the paragraph above. It is possible that he decides to re-read the same book several times.

After making this plan, he realized that the total weight of books he should lift during m days would be too heavy. So, he decided to change the order of the stacked books before the New Year comes, and minimize the total weight. You may assume that books can be stacked in any possible order. Note that book that he is going to read on certain step isn't considered as lifted on that step. Can you help him?

Input

The first line contains two space-separated integers n (2 ≤ n ≤ 500) and m (1 ≤ m ≤ 1000) — the number of books, and the number of days for which Jaehyun would read books.

The second line contains n space-separated integers w1, w2, ..., wn (1 ≤ wi ≤ 100) — the weight of each book.

The third line contains m space separated integers b1, b2, ..., bm (1 ≤ bj ≤ n) — the order of books that he would read. Note that he can read the same book more than once.

Output

Print the minimum total weight of books he should lift, which can be achieved by rearranging the order of stacked books.

Examples
input
3 51 2 31 3 2 3 1
output
12
Note

Here's a picture depicting the example. Each vertical column presents the stacked books.


题意:一个人要读n本书每本书有个重量 w [ i ],要读 m 天,每天读1本,他每天把要看的书抽出来(把上面的搬开,拿出要读的书再把上面的书放回去),看完以后放到一摞书的最上面,问根据他的阅读顺序怎样初始化书的排列顺序能使他搬书的重量最小,求出这个最小重量

题解:先看一个序列1 1 1 1 1 1 1 2,对于这个序列,我们很明显的策略是按1 2来排,因为看过以后放在最上面,所以每次读1都不用搬书,对于一个阅读序列的子序列a b,我们有两种排法,按a b排代价是w[b],按b a排代价是w[a] + w[b],而且要明确的一点是确定了顺序,代价也就随之确定了,我们再将这个性质推广到一般得出贪心结论:拿每本书第一次出现的顺序作为初始序列,比如1 1 3 1 1 3 2 1 1 按此策略得到的初始序列为1 3 2,不管初始序列是什么样的,读完 1 1 3以后的书的顺序肯定都是确定的都为3 1 2,但是只有初始序列为1 3 2时得到3 1 2的代价最小。由此可以得到结论:初始化书的最优排列顺序就是:按照看书顺序每一本第一次依次出现的顺序。如样例 1 3 2 3 1 ,那么最优顺序就是 1 3 2 

/* #include<cstdio>#include<algorithm>#include<cstring>using namespace std;int n,m;int w[510],b[1010];bool vis[1010];int main(){while(~scanf("%d %d",&n,&m)){for(int i=1;i<=n;i++)scanf("%d",&w[i]);for(int i=1;i<=m;i++)scanf("%d",&b[i]);int ans=0;for(int i=1;i<=m;i++){memset(vis,0,sizeof(vis));for(int j=i-1;j>=1;j--) {if(b[i]==b[j])break; // 当找到相同时,已经拿完了放在 b[i]上面的书 if(!vis[b[j]]) // 已经拿过的书就不用再拿了 {ans+=w[b[j]];vis[b[j]]=1;}}}printf("%d\n",ans);}return 0;}*/// STL 实现 #include<cstdio>#include<algorithm>#include<cstring>#include<vector>using namespace std;int n,m;int w[510],b[1010];bool vis[1010];vector<int> G;int main(){while(~scanf("%d %d",&n,&m)){memset(vis,0,sizeof(vis));G.clear();for(int i=1;i<=n;i++)scanf("%d",&w[i]);for(int i=1;i<=m;i++){scanf("%d",&b[i]);if(!vis[b[i]]){G.push_back(b[i]);vis[b[i]]=1;}}int ans=0;for(int i=1;i<=m;i++){for(int j=0;j<G.size();j++){if(b[i]==G[j]){G.erase(G.begin()+j);G.insert(G.begin(),b[i]);break;}elseans+=w[G[j]];}}printf("%d\n",ans);}return 0;}

0 0